'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _draftJs = require("draft-js");

var _ButtonGroup = require("./ButtonGroup.jsx");

var _ButtonGroup2 = _interopRequireDefault(_ButtonGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BasicEditor = function (_React$Component) {
	_inherits(BasicEditor, _React$Component);

	function BasicEditor(props) {
		_classCallCheck(this, BasicEditor);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(BasicEditor).call(this, props));

		var editorState = _draftJs.EditorState.createEmpty();
		console.log("props.value: ", props.value);
		if (props.value) {
			editorState = _draftJs.EditorState.createWithContent(_draftJs.ContentState.createFromText(props.value));
		}
		_this.state = { editorState: editorState };
		_this.onChange = function (editorState) {
			return _this.setState({ editorState: editorState });
		};
		_this.handleKeyCommand = _this.handleKeyCommand.bind(_this);
		return _this;
	}

	_createClass(BasicEditor, [{
		key: "handleKeyCommand",
		value: function handleKeyCommand(command) {
			var newState = _draftJs.RichUtils.handleKeyCommand(this.state.editorState, command);
			if (newState) {
				this.onChange(newState);
				return true;
			}
			return false;
		}
	}, {
		key: "_onBoldClick",
		value: function _onBoldClick() {
			this.onChange(_draftJs.RichUtils.toggleInlineStyle(this.state.editorState, 'BOLD'));
		}
	}, {
		key: "_onUnderlineClick",
		value: function _onUnderlineClick() {
			this.onChange(_draftJs.RichUtils.toggleInlineStyle(this.state.editorState, 'UNDERLINE'));
		}
	}, {
		key: "_onItalicClick",
		value: function _onItalicClick() {
			this.onChange(_draftJs.RichUtils.toggleInlineStyle(this.state.editorState, 'ITALIC'));
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props;
			var id = _props.id;
			var value = _props.value;
			var disabled = _props.disabled;


			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(
					_ButtonGroup2.default,
					null,
					_react2.default.createElement(
						"button",
						{ "class": "btn btn-default btn-xs", onClick: this._onBoldClick.bind(this) },
						_react2.default.createElement("span", { "class": "glyphicon glyphicon-bold", "aria-hidden": "true" })
					),
					_react2.default.createElement(
						"button",
						{ "class": "btn btn-default btn-xs", onClick: this._onUnderlineClick.bind(this) },
						_react2.default.createElement("span", { "class": "fa fa-underline", "aria-hidden": "true" })
					),
					_react2.default.createElement(
						"button",
						{ "class": "btn btn-default btn-xs", onClick: this._onItalicClick.bind(this) },
						_react2.default.createElement("span", { "class": "glyphicon glyphicon-italic", "aria-hidden": "true" })
					)
				),
				_react2.default.createElement(
					"div",
					{ "class": "panel panel-default" },
					_react2.default.createElement(
						"div",
						{ "class": "panel-body" },
						_react2.default.createElement(_draftJs.Editor, { id: id,
							editorState: this.state.editorState,
							handleKeyCommand: this.handleKeyCommand,
							onChange: this.onChange })
					)
				)
			);
		}
	}]);

	return BasicEditor;
}(_react2.default.Component);

exports.default = BasicEditor;